
void init_socket()
{
	int ret;
	sigset_t ens , ens_old;
	struct sockaddr_in mon_address;
	struct sigaction action;
	buffer=malloc(MAX_CARACT+1);

	printf("INITIALISATION\n");
	bzero(&mon_address,sizeof(mon_address));
	mon_address.sin_port = htons(PORT);
	mon_address.sin_family = AF_INET;
	mon_address.sin_addr.s_addr = htonl(INADDR_ANY);

	/** creation de socket, protocole TCP */
	if ((ma_socket = socket(AF_INET,SOCK_STREAM,0))== -1)
	{
  		printf("Problème avec la creation\n");
  		exit(0);
	}

	sigfillset(&ens);
	sigdelset(&ens , SIGINT);
	sigdelset(&ens , SIGCHLD); 
	sigprocmask(SIG_SETMASK , &ens , &ens_old );
	
	action.sa_handler = SIGCHLD_handler;
	action.sa_mask = ens;
	action.sa_flags = SA_RESTART;

	if ( sigaction(SIGCHLD , &action , NULL) == -1 )
	{
		perror("sigaction");
  		exit(1);
	}


	setbuf(stdout, NULL);
	setbuf(stdin, NULL);
	signal(SIGINT, SIGINT_handler);
	signal(SIGCHLD , SIGCHLD_handler);

	
   	ret = bind(ma_socket,(struct sockaddr *)&mon_address, sizeof(mon_address));
   	if (ret!=0)
   	{
     		perror("bind()");
     		exit(1);
   	}

	/** ecoute sur la socket */
	ret = listen(ma_socket,LISTE_ATTENTE);
   	if (ret!=0)
   	{
      		perror("listen()");
     		exit(1);
   	}
}

 /*char *ecoute(void)
{
read(client_socket,buffer, MAX_CARACT);
return buffer;
}


void envoi_chaine(char *msg, num_socket)
{
	write(to_server_socket,msg,MAX_CARACT);
}*/

void *routine (void *arg)
{

    int *status = malloc (sizeof(int)); /* pour renvoyer le code de retour */
    printf ("Arg = %d\n", *(int *)arg); /* casting vers (int *) necessaire */
    *status = *(int *)arg * 2;
    pthread_exit (status);

}


void attente_client(void)
{
  /*  pthread_t un_p;
    int erreur, argument = 3;
    int *resultat;
    erreur = pthread_create (&un_p, NULL, routine, &argument);
    if (erreur != 0) fprintf(stderr,"Echec creation de thread: %d\n",erreur);
    pthread_join (un_p, (void **)&resultat);
    printf ("Resultat: %d\n", *resultat);
    free (resultat);
    exit(0);*/
}

 char *ecoute(void)
{  
	socklen_t longueur;
	struct sockaddr_in client_address;
	int mon_address_longueur, lg=512;

	mon_address_longueur = sizeof(client_address);
	longueur = sizeof(client_address);

	/**Attend une connection de la part d'un client*/
	client_socket = accept(ma_socket,
               	         (struct sockaddr *)&client_address,
               	         &longueur);
	ip_client=inet_ntoa(client_address.sin_addr);
	lg = read(client_socket,buffer, MAX_CARACT);
	write(client_socket,buffer, MAX_CARACT);
	return buffer;
}

void actualise(char *message)
{
	struct profil client;
	int j=0,i=0,nb_utilisateur;

	if(!strcmp(actualisation, "demande_liste_contacts"))
	{
		while(strcmp(message, "fin_liste_contacts"))
		{	
			strcpy(client.contact[j],message);
			++j; 
			message=ecoute();
		}
		client.nb_contacts=j;
		actualisation="actualisé";
	}

	if(!strcmp(actualisation, "demande_etat"))
	{
		strcpy(client.etat,message);
		actualisation="demande_liste_contacts";
	}

	if(!strcmp(actualisation, "demande_pseudo"))
	{
		strcpy(client.nom_utilisateur,message);
		actualisation="demande_etat";
	}

	if(!strcmp(message, "actualise_donnees") && !strcmp(actualisation, "pas d'actualisation") )
	{
		actualisation="demande_pseudo";
	}
	strcpy(client.ip,ip_client);
 	client.socket=client_socket;

/**Recherche le numéro du client qui veut s'actualiser*/
	if (!strcmp(actualisation, "actualisé"))
	{
		while(i<MAXCLIENTS)
		{
			if(!strcmp(informations_client[i].nom_utilisateur,client.nom_utilisateur))	
			{
				nb_utilisateur=i;
				i=MAXCLIENTS+1;
			}
			i++;
		}
		i=0;
		actualisation="fin_actualisation";
	}

	if (!strcmp(actualisation, "fin_actualisation"))
	{
		informations_client[nb_utilisateur]=client;
		actualisation="pas d'actualisation";
	}
}

int connection(char *message, int nb_utilisateur)
{
	struct profil client;
	int j=0,i=0;

	if(!strcmp(connexion, "demande_liste_contacts"))
	{
		while(strcmp(message, "fin_liste_contacts"))
		{	
			strcpy(client.contact[j],message);
			++j; 
			message=ecoute();
		}
		client.nb_contacts=j;
		connexion="connecté";
	}

	if(!strcmp(connexion, "demande_etat"))
	{
		strcpy(client.etat,message);
		connexion="demande_liste_contacts";
	}

	if(!strcmp(connexion, "demande_pseudo"))
	{
		strcpy(client.nom_utilisateur,message);
		connexion="demande_etat";
	}

	if(!strcmp(message, "connexion_de_l_utilisateur") && !strcmp(connexion, "non connecté") )
	{
		connexion="demande_pseudo";
	}
	strcpy(client.ip,ip_client);
 	client.socket=client_socket;

 	if (!strcmp(connexion, "connecté"))
 	{
 		while(i<MAXCLIENTS)
 		{
 			if(!strcmp(informations_client[i].nom_utilisateur,client.nom_utilisateur))	
 			{
 				printf("Utilisateur déjà connecté\n");
				return 0;
 			}
 			i++;
 		}
		connexion="fin_connexion";
 	}

	if (!strcmp(connexion, "fin_connexion"))
	{
			informations_client[nb_utilisateur]=client;
			connexion="non connecté";
			return 1;
	}
return 0;
}


int retransmission_message(char *message)
{
	int i=0;
	int num_source,num_destinataire;
	char nom_destinataire[MAX_CARACT],nom_source[MAX_CARACT];
	char etat_destinataire[MAX_CARACT];
	strcpy(etat_destinataire,"déconnecté");
	
	if(!strcmp(message, "envoi_d_un_message_a_un_destinataire"))
	{
		message=ecoute();
		strcpy(nom_source,message);
		message=ecoute();
		strcpy(nom_destinataire,message);
		message=ecoute();

		while(i<MAXCLIENTS)
		{
			if(!strcmp(informations_client[i].nom_utilisateur,nom_source))	
			{
				num_source=i;
				i=MAXCLIENTS+1;
			}
			i++;
		}
		i=0;

		/**Cherche si le destinataire est connecté*/
		while(i<MAXCLIENTS)
		{
			if(!strcmp(informations_client[i].nom_utilisateur,nom_destinataire))	
			{
				num_destinataire=i;
				i=MAXCLIENTS+1;
				strcpy(etat_destinataire,"connecté");
			}
			i++;
		}

		/**Affiche sur le serveur et envoi au destinataire(si il existe) le message qui lui est destiné*/
		if (!strcmp(etat_destinataire,"déconnecté"))
		{
			strcpy(message,"=========>  DESTINATAIRE DECONNECTE OU INEXISTANT");
			/**Ici, c'est de la bidouille*/
			write(client_socket,message,MAX_CARACT);
			printf("%s\n",message);
		}
		else
		{
 		printf("Le client n°%d, '%s' d'adresse IP '%s' et de socket n° %d envoi\n'%s' au client n°%d, '%s' d'adresse ip '%s' et de socket n°%d\n",num_source,informations_client[num_source].nom_utilisateur,informations_client[num_source].ip,informations_client[num_source].socket,message,num_destinataire,informations_client[num_destinataire].nom_utilisateur,informations_client[num_destinataire].ip,informations_client[num_destinataire].socket);

		/**Ici, c'est de la bidouille*/
		printf("clientsocket = %d\n",client_socket);
		write(client_socket,"Un_Client_Vous_Envoi",MAX_CARACT);
		write(client_socket,informations_client[num_source].nom_utilisateur,MAX_CARACT);
		write(client_socket,message,MAX_CARACT);
		}
	}	
return 0;
}

int deconnexion(char *message)
{
int i=0;
int nb_utilisateur;
	if(!strcmp(message, "deconnexion_de_l_utilisateur"))
	{
		message=ecoute();

		/**Recherche l'utilisateur à déconnecter*/
		while(i<MAXCLIENTS)
		{
			if(!strcmp(informations_client[i].nom_utilisateur,message))	
			{
				nb_utilisateur=i;
				i=MAXCLIENTS+1;
			}
			i++;
		}
		i=0;

		/**Décale tous les clients connectés à partir du client déconnecté*/
		while (nb_utilisateur<MAXCLIENTS)
		{

			strcpy(informations_client[nb_utilisateur].nom_utilisateur,informations_client[nb_utilisateur+1].nom_utilisateur);
			strcpy(informations_client[nb_utilisateur].etat,informations_client[nb_utilisateur+1].etat);
			strcpy(informations_client[nb_utilisateur].ip,informations_client[nb_utilisateur+1].ip);

			/**décale la liste de contacts de l'utilisateur*/
			while(i<informations_client[nb_utilisateur].nb_contacts)
			{	
				strcpy(informations_client[nb_utilisateur].contact[i],informations_client[nb_utilisateur+1].contact[i]);
				++i; 
			}
			informations_client[nb_utilisateur].nb_contacts=informations_client[nb_utilisateur+1].nb_contacts;
			nb_utilisateur++;
		}
		return 1;	
	}
	return 0;
}
	

void initialisation_infos_clients(void)
{
	int i=0,j=0;
	while(i<MAXCLIENTS)
	{
		strcpy(informations_client[i].nom_utilisateur,"");
		strcpy(informations_client[i].etat,"");
		strcpy(informations_client[i].ip,"");
	
		/**Initialise la liste de contacts de l'utilisateur*/
		while(j<=MAXCONTACTS)
		{	
			strcpy(informations_client[j].contact[j],"");
			++j; 
		}
		informations_client[j].nb_contacts=0;	
		i++;
	}
}

void vidage_client(int i)
{
int j=0;

		strcpy(informations_client[i].nom_utilisateur,"");
		strcpy(informations_client[i].etat,"");
		strcpy(informations_client[i].ip,"");

		/**Initialise la liste de contacts de l'utilisateur*/
		while(j<=MAXCONTACTS)
		{	
			strcpy(informations_client[i].contact[j],"");
			++j; 
		}
		informations_client[i].nb_contacts=0;	
}

void affiche_utilisateur_connecte(int j)
{
	int i=0;
	printf("\n--------------UTILISATEUR N°%d ENREGISTRE----------------\n",j+1);
	printf("nom d'utilisateur : %s\nAdresse IP : %s\nEtat : %s\n", informations_client[j].nom_utilisateur,informations_client[j].ip,informations_client[j].etat);
	printf("Voici sa liste de contact : \n");
	while(i<informations_client[j].nb_contacts)
	{	
		printf("contact n°%d = %s\n",i+1,informations_client[j].contact[i]); 
		++i; 
	}
}

void SIGCHLD_handler(void)
{
	wait(NULL);
	printf("fils mort\n");
}

void SIGINT_handler(void)
{
	printf("SIGINT\n");
	if ( shutdown(ma_socket , 2)==-1){
	perror("shutdown");
	}
	else
	close(ma_socket);
  	exit(0);
}

