

struct profil connexion(void)
{	
	char nom_utilisateur[MAX_CARACT];
	int i=1; 
	int j=0;
	envoi_chaine("connexion_de_l_utilisateur");
	printf("Tapez votre nom d'utilisateur:");
	fgets(nom_utilisateur,sizeof(nom_utilisateur),stdin);
 	clean(nom_utilisateur);
	printf("Tapez votre état (En ligne = 1, Absent = 2, Occupé = 3, A table = 4, Hors ligne = 0):");
	scanf("%d",&i);
	strcpy(client1.nom,nom_utilisateur);

/**En ligne = 1, Absent = 2, Occupé = 3, A table = 4, Hors ligne = 0*/
	if (i==1)	client1.etat="En ligne";
	if (i==2)	client1.etat="Absent";
	if (i==3)	client1.etat="Occupé";
	if (i==4)	client1.etat="A table";
	if (i==0)	client1.etat="Hors ligne";	

	envoi_chaine(client1.nom);
	envoi_chaine(client1.etat);

/** Chargement de la liste des contacts à partir du fichier "contacts.txt" mis sous formes d'un tableau de chaines dans la structure */
	nb_contacts = recup_contacts();

while(j < nb_contacts) 
{  	
	envoi_chaine(client1.contact[j]); 
 	++j; 
 }
	envoi_chaine("fin_liste_contacts");
	return client1;
}


void deconnexion(char *pseudo)
{
	envoi_chaine("deconnexion_de_l_utilisateur");
	envoi_chaine(pseudo);

	/** fermeture de la connection */
 	shutdown(to_server_socket,2);
	close(to_server_socket);
}

/*void envoi_chaine(char *msg)
{
	premiere_connexion();
	write(to_server_socket,msg,MAX_CARACT);
}*/

char *recoit_chaine(void)
{
	char *message_recu;
	message_recu = malloc(MAX_CARACT+1);
 	read(to_server_socket,message_recu,MAX_CARACT);
	return message_recu;
}

void envoi_chaine(char *msg)
{
	struct sockaddr_in serverSockAddr;
	struct hostent *serverHostEnt;
	long hostAddr;
	
	bzero(&serverSockAddr,sizeof(serverSockAddr));
	hostAddr = inet_addr(SERVEURNAME);
	if ( (long)hostAddr != (long)-1)
	bcopy(&hostAddr,&serverSockAddr.sin_addr,sizeof(hostAddr));
	else
	{
		serverHostEnt = gethostbyname(SERVEURNAME);
		if (serverHostEnt == NULL)
		{
			printf("problème avec gethost\n");
			exit(0);
		}
		bcopy(serverHostEnt->h_addr,&serverSockAddr.sin_addr,serverHostEnt->h_length);
	}
	serverSockAddr.sin_port = htons(PORT);
	serverSockAddr.sin_family = AF_INET;
	
	/** création de la socket */
	if ( (to_server_socket = socket(AF_INET,SOCK_STREAM,0)) < 0)
	{
		printf("problème avec socket client\n");
		exit(0);
	}
	
	/** requête de connexion */
	if(connect( to_server_socket,
		(struct sockaddr *)&serverSockAddr,
		sizeof(serverSockAddr)) < 0 )
	{
		printf("problème de demande de connection\n");
		exit(0);
	}
	write(to_server_socket,msg,MAX_CARACT);
	read(to_server_socket,buffer,MAX_CARACT);
}

struct profil actualise_donnees(int i, int k)
{
	int j=0;
	
	/**Prévient le serveur qu'un utilisateur veut actualiser ses données*/
	envoi_chaine("actualise_donnees");
	
	if (i>=0)	/**Si i est inférieur à O alors l'état reste inchangé*/
	{
		if (i==1)	client1.etat="En ligne";
		if (i==2)	client1.etat="Absent";
		if (i==3)	client1.etat="Occupé";
		if (i==4)	client1.etat="A table";
		if (i==0)	client1.etat="Hors ligne";		
	}	
	envoi_chaine(client1.nom);
	envoi_chaine(client1.etat);
	
	/**Chargement de la liste des contacts à partir du fichier "contacts.txt" mis sous formes d'un tableau de chaines dans la structure */
	if (k>=0)	nb_contacts = recup_contacts();/**Si k est inférieur à 0 alors la liste d'utilisateur reste inchangée*/
	
	while(j < nb_contacts) 
	{  	
		envoi_chaine(client1.contact[j]); 
		++j; 
	}
		
	/**Signale la fin de l'envoi de la liste de contacts au serveur*/
	envoi_chaine("fin_liste_contacts");
	return client1;
}


void envoi_msg(char *source, char *destinataire, char *msg)
{
	envoi_chaine("envoi_d_un_message_a_un_destinataire");
	envoi_chaine(source);
	envoi_chaine(destinataire);
	envoi_chaine(msg);
}


static void purger(void)
 {
     int c;
     while ((c = getchar()) != '\n' && c != EOF)
     {}
 }

/**Retire le dernier caractère :\n d'une chaine fgets*/
 static void clean (char *chaine)
 {
     char *p = strchr(chaine, '\n');

     if (p)
     {
         *p = 0;
     }
     else
     {
         purger();
     }
 }



void demande_et_ajout_contact(void)
{
	int j=0;
	char noms_contacts[MAX_CARACT];
	do{
		j++;
		clean(noms_contacts);
		printf("Tapez le nom du contact n°%d à ajouter (entrez 'exit' pour arrêter): ",j);
    		fgets(noms_contacts, sizeof (noms_contacts), stdin);
		clean(noms_contacts);
		ajout_contact(noms_contacts);
		if (strcmp(noms_contacts, "exit"))	printf("Contact ajouté!\n");
		else	printf("Quitte la fonction...\n");
	  }while(strcmp(noms_contacts, "exit"));
}



void ajout_contact(char *pseudo_contact)
{
	if  (strcmp(pseudo_contact, "exit"))
	{
		int i=0,j=0,x=0;
		FILE *contacts; 
		FILE *temp;
		char szBuffer; 
		char phrase[MAX_CARACT];
		
		if((contacts = fopen("contacts.txt", "r")) != NULL) /**on ouvre le fichier et verifie si on y arrive */
		{ 
			do
			{
				j++;
				fscanf(contacts,"%d",&x);
			}while(fgets(phrase, sizeof(phrase)/sizeof(*phrase), contacts) != NULL  && i<MAXCONTACTS );
	
			fclose(contacts); 
		}
			
		if((contacts = fopen("contacts.txt", "r")) != NULL) /**on ouvre le fichier et verifie si on y arrive */
		{ 
			temp=fopen("temp.txt", "w");
			if(temp==NULL)	printf("Erreur\n");	
				
			/**si on arrive a ouvrir le fichier tant que l'on est pas a la fin */
			while (!feof(contacts)) 
			{ 
				fread(&szBuffer, 1, 1, contacts); /**on range les caracteres dans le buffer*/
				if (szBuffer == '\n') /**On va remplacer chaque retour à la ligne*/ 
				{
					i++;
					if (i==j)	fprintf(temp,"%d %s\n",i,pseudo_contact); 
					else if	(i<j)	fprintf(temp,"\n");
				}
				else fprintf(temp,"%c", szBuffer); /**on ajoute dans le fichier ce que contient le buffer*/
			} 
		} 
		fclose(contacts); 
		fclose(temp);
		remove("contacts.txt");
		rename("temp.txt","contacts.txt");
	}
}


int recup_contacts ( void )
{
int i=0, x=0,rc;
FILE *contacts;
char phrase[MAX_CARACT+1]; 

if((contacts = fopen("contacts.txt", "r")) != NULL) /**on ouvre le fichier et verifie si on y arrive */
{
	while(fgets(phrase, sizeof(phrase)/sizeof(*phrase), contacts) != NULL  && i<MAXCONTACTS )
	{
		rc = sscanf(phrase,"%d %s",&x, client1.contact[i]);
		++i;
	} 
	fclose(contacts);
}

return i;
}


